#include <windows.h>
#include <stdio.h>

#define EXPORT __declspec(dllexport)

#include "../include/dwterm.h"



DWTRMF *dwt;



// Read the file and count values in the specified ranges.



//***********************************************************************
//                        Load & Unload
//***********************************************************************


EXPORT char *dwTermH_Load (char *CmdLine, char **title, DWTRMF *dwtf)
   {
   dwt=dwtf;
   *title="Count";

   dwt->ShowDisplay(FALSE);
          // Show the text window instead of the graphics window.

   return NULL;
   }



//***********************************************************************
//                           Command
//***********************************************************************


#define RetErrorWrongNumber { \
   return "Error! Wrong number of tokens."; \
}


#define RetErrorWrongToken { \
   return "Error! A wrong token."; \
}


EXPORT char *dwTermH_Command (int nToken, char **token)
   {

   int i=0; double value, r1, r2; FILE *hFile;
   if(nToken<=0) return NULL;

   if(!strcmp(token[0], "r"))
      { // Count values in the Range [v1, v2).
      if(nToken==3)
         {
         hFile=fopen("data", "rb");
         r1=atof(token[1]);
         r2=atof(token[2]);

         while(dwt->ReadNumber(&value, hFile))
            {
            if( (value<r2) && (value>=r1) ) i++;
            }

         dwt->Printf(1, "%d values in [%3.1f, %3.1f)", i, r1, r2);
         return NULL;
         }
      RetErrorWrongNumber
      }

   if(!strcmp(token[0], "b"))
      { // Count values Below the limit.
      if(nToken==2)
         {
         hFile=fopen("data", "rb");
         r2=atof(token[1]);

         while(dwt->ReadNumber(&value, hFile))
            {
            if(value<r2) i++;
            }

         dwt->Printf(1, "%d values below %3.1f", i, r2);
         return NULL;
         }
      RetErrorWrongNumber
      }

   if(!strcmp(token[0], "ge"))  
      { // Count values greater than or equal to the limit.
      if(nToken==2)
         {
         hFile=fopen("data", "rb");
         r1=atof(token[1]);

         while(dwt->ReadNumber(&value, hFile))
            {
            if(value>=r1) i++;
            }

         dwt->Printf(1, "%d values greater than or equal to %3.1f", i, r1);
         return NULL;
         }
      RetErrorWrongNumber
      }

   RetErrorWrongToken
   }
